"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styled = _interopRequireDefault(require("@emotion/styled"));

var _lodash = require("lodash");

var _animations = _interopRequireDefault(require("../../themes/animations"));

var _util = require("../../util");

var _common = require("../common");

var _NodeHeader = _interopRequireDefault(require("../NodeHeader"));

var _Drawer = _interopRequireDefault(require("./Drawer"));

var _Loading = _interopRequireDefault(require("./Loading"));

var _core = require("@material-ui/core");

var _styles = require("@material-ui/core/styles");

var _styles2 = _interopRequireDefault(require("../../themes/styles2"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

// const Li = styled('li', {
//     shouldForwardProp: prop => ['className', 'children', 'ref'].indexOf(prop) !== -1
// })(({style}) => style);
var TreeNode = /*#__PURE__*/function (_PureComponent) {
  _inherits(TreeNode, _PureComponent);

  var _super = _createSuper(TreeNode);

  function TreeNode() {
    _classCallCheck(this, TreeNode);

    return _super.apply(this, arguments);
  }

  _createClass(TreeNode, [{
    key: "onClick",
    value: function onClick() {
      var _this$props = this.props,
          node = _this$props.node,
          onToggle = _this$props.onToggle;

      if (onToggle) {
        onToggle(node, !node.toggled);
      }
    }
  }, {
    key: "animations",
    value: function animations() {
      var _this$props2 = this.props,
          animations = _this$props2.animations,
          node = _this$props2.node;

      if (!animations) {
        return {
          toggle: _animations["default"].toggle(this.props, 0)
        };
      }

      var animation = Object.assign({}, animations, node.animations);
      return {
        toggle: animation.toggle(this.props),
        drawer: animation.drawer(this.props)
      };
    }
  }, {
    key: "decorators",
    value: function decorators() {
      var _this$props3 = this.props,
          decorators = _this$props3.decorators,
          node = _this$props3.node;
      var nodeDecorators = node.decorators || {};
      return Object.assign({}, decorators, nodeDecorators);
    } // operator content - via styles

  }, {
    key: "createOperatorContentClass",
    value: function createOperatorContentClass(operator) {
      var classes2 = (0, _styles.makeStyles)({
        operator: {
          '&::before': {
            content: "\"".concat(operator, "\"")
          }
        }
      })();
      return classes2.operator;
    }
  }, {
    key: "createPath",
    value: function createPath() {
      var _this$props4 = this.props,
          path = _this$props4.path,
          treeIndex = _this$props4.treeIndex; // console.log(treeIndex, path);

      return [].concat(_toConsumableArray(path), [treeIndex]);
    }
  }, {
    key: "renderChildren",
    value: function renderChildren(decorators, path) {
      var _this$props5 = this.props,
          animations = _this$props5.animations,
          propDecorators = _this$props5.decorators,
          node = _this$props5.node,
          style = _this$props5.style,
          onToggle = _this$props5.onToggle,
          onSelect = _this$props5.onSelect,
          customStyles = _this$props5.customStyles,
          actionHandler = _this$props5.actionHandler,
          childIndex = _this$props5.treeIndex,
          onSelectConnector = _this$props5.onSelectConnector; // console.log(this.props.path, path);

      if (node.loading) {
        return /*#__PURE__*/_react["default"].createElement(_Loading["default"], {
          decorators: decorators,
          style: this.props.classes
        });
      }

      var children = node.children;

      if (!(0, _lodash.isArray)(children)) {
        children = children ? [children] : [];
      } // const useStyles = makeStyles((theme) => styles(theme));
      // const classes = useStyles();
      // operator content - via styles

      /* const classes2 = makeStyles({
          operator: {        
              '&::before': {
                  content: `"${node.operator}"`,
              }
          }
      })(); */


      var classes = this.props.classes;
      return (
        /*#__PURE__*/
        // <>
        _react["default"].createElement(_core.Grid, {
          item: true,
          xs: 12,
          className: classes.nodeL
          /* onClick={onSelect} */

        }, children.length > 1 && /*#__PURE__*/_react["default"].createElement("div", {
          className: classes.operator
          /* onClick={onSelectConnector} */
          ,
          onClick: function onClick(e) {
            // console.log('Hello Bamiyooo!', e, children, path);
            return typeof onSelectConnector === 'function' ? onSelectConnector(children, path) : undefined;
          }
        }, node.operator), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
          container: true,
          spacing: 3,
          className: "".concat(classes.nodeC, " ")
        }, children.map(function (child, childIndex) {
          /* console.log(child); */
          return /*#__PURE__*/_react["default"].createElement(TreeNode, {
            onSelect: onSelect,
            onToggle: onToggle,
            animations: animations,
            style: style,
            customStyles: customStyles,
            decorators: propDecorators,
            key: child.id || (0, _util.randomString)(),
            node: child,
            classes: classes,
            actionHandler: actionHandler,
            treeIndex: childIndex,
            path: path,
            onSelectConnector: onSelectConnector
          });
        }))) // </>

      );
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props6 = this.props,
          node = _this$props6.node,
          style = _this$props6.style,
          onSelect = _this$props6.onSelect,
          customStyles = _this$props6.customStyles,
          actionHandler = _this$props6.actionHandler,
          treeIndex = _this$props6.treeIndex,
          onSelectConnector = _this$props6.onSelectConnector;
      var decorators = this.decorators();
      var animations = this.animations();
      var path = this.createPath();

      var restAnimationInfo = _extends({}, animations.drawer);

      var classes = this.props.classes;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_NodeHeader["default"], {
        decorators: decorators,
        animations: animations,
        node: node,
        style: style,
        customStyles: customStyles,
        onClick: function onClick() {
          return _this.onClick();
        },
        onSelect: (0, _lodash.isFunction)(onSelect) ? function () {
          return onSelect(node, path);
        } : undefined,
        classes: classes,
        actionHandler: (0, _lodash.isFunction)(actionHandler) ? function (e) {
          return actionHandler(e, node, treeIndex, path);
        } : undefined,
        treeIndex: treeIndex,
        path: path,
        onSelectConnector: (0, _lodash.isFunction)(onSelectConnector) ? function () {
          return onSelectConnector(node, path);
        } : undefined
      }), /*#__PURE__*/_react["default"].createElement(_Drawer["default"], {
        restAnimationInfo: _objectSpread({}, restAnimationInfo)
      }, node.toggled ? this.renderChildren(decorators, path, node, onSelectConnector, animations) : null));
    }
  }]);

  return TreeNode;
}(_react.PureComponent);

TreeNode.propTypes = {
  onSelect: _propTypes["default"].func,
  onToggle: _propTypes["default"].func,
  style: _propTypes["default"].object.isRequired,
  customStyles: _propTypes["default"].object,
  node: _propTypes["default"].object.isRequired,
  decorators: _propTypes["default"].object.isRequired,
  animations: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].bool]).isRequired,
  classes: _propTypes["default"].object,
  actionHandler: _propTypes["default"].func,
  treeIndex: _propTypes["default"].number,
  path: _propTypes["default"].array,
  onSelectConnector: _propTypes["default"].func
};
TreeNode.defaultProps = {
  customStyles: {}
}; // export default TreeNode;

var _default = (0, _styles.withStyles)(_styles2["default"])(TreeNode);

exports["default"] = _default;