"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _common = require("../common");

var _styles = require("@material-ui/core/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import styled from '@emotion/styled';
// const Polygon = styled('polygon', {
//     shouldForwardProp: prop => ['className', 'children', 'points'].indexOf(prop) !== -1
// })((({style}) => style));
var styles = function styles() {
  return {
    root: {},
    operator: {
      transform: 'rotateZ(0deg)',
      top: '49%',
      position: 'absolute',
      zIndex: 111,
      border: '1px solid #FFF',
      padding: '0.1rem 0.5rem',
      borderRadius: '1rem',
      background: '#666',
      left: '8.5%'
    }
  };
};

var Toggle = function Toggle(_ref) {
  var style = _ref.style,
      onClick = _ref.onClick,
      node = _ref.node,
      classes = _ref.classes;
  // const {height, width} = style;
  // const midHeight = height * 0.5;
  // const points = `0,0 0,${height} ${width},${midHeight}`;
  // const { classes } = this.props;
  return (
    /*#__PURE__*/
    // <div style={style.base} onClick={onClick}>
    //     <Div style={style.wrapper}>
    //         {/* <svg {...{height, width}}>
    //             <Polygon points={points} style={style.arrow}/>
    //         </svg> */}
    //     </Div>
    // </div>
    _react["default"].createElement("div", {
      onClick: onClick,
      className: classes.operator,
      style: {
        'visibility': 'hidden'
      }
    }, node.operator) // <></>

  );
};

Toggle.propTypes = {
  onClick: _propTypes["default"].func.isRequired,
  style: _propTypes["default"].object,
  node: _propTypes["default"].object,
  classes: _propTypes["default"].any
};

var _default = (0, _styles.withStyles)(styles)(Toggle);

exports["default"] = _default;