"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findObjectByLabel = void 0;
exports.getDepth = getDepth;
exports.removeNode = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var removeNode = function removeNode(treeData, node, path, index) {
  var newNode = {};
  return newNode;
};
/**
 * Get the maximum depth of the children (the depth of the root node is 0).
 *
 * @param {!Object} node - Node in the tree
 * @param {?number} depth - The current depth
 *
 * @return {number} maxDepth - The deepest depth in the tree
 */


exports.removeNode = removeNode;

function getDepth(node) {
  var depth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  if (!node.children) {
    return depth;
  }

  if (typeof node.children === 'function') {
    return depth + 1;
  }

  return node.children.reduce(function (deepest, child) {
    return Math.max(deepest, getDepth(child, depth + 1));
  }, depth);
}

var findObjectByLabel = function findObjectByLabel(obj, label) {
  for (var elements in obj) {
    if (elements === label) {
      console.log(obj[elements]);
    }

    if (_typeof(obj[elements]) === 'object') {
      findObjectByLabel(obj[elements], 'jssType');
    }
  }
}; // findObjectByLabel(treeData, 'jssType');


exports.findObjectByLabel = findObjectByLabel;